----------
--models--
----------

E_MODEL_BIG_STAR = smlua_model_util_get_id("evil_star_geo")
E_MODEL_SECRETS = smlua_model_util_get_id("secret_star_geo")
E_MODEL_STAR_SPAWN = smlua_model_util_get_id("star_spawn_geo")
E_MODEL_UNTRIFORCE = smlua_model_util_get_id("triforce_piece_geo")

-- Thanks Blocky, SonicDark and PeachyPeach!

function bhv_custom_secrets_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj_set_model_extended(o, E_MODEL_SECRETS)
end

function bhv_custom_secrets_loop(o)
    o.oFaceAngleYaw = o.oFaceAngleYaw + 0x800
    local secret = obj_get_nearest_object_with_behavior_id(o, id_bhvHiddenStarTrigger)
    if secret == nil or secret.oPosX ~= o.oPosX or secret.oPosY ~= o.oPosY or secret.oPosZ ~= o.oPosZ then
        obj_mark_for_deletion(o)
    end
end

function bhv_untriforce_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj_set_hitbox(o, sCustomSecretHitbox)
	obj_set_model_extended(o, E_MODEL_UNTRIFORCE)
end

function bhv_untriforce_loop(o)
    o.oFaceAngleYaw = o.oFaceAngleYaw + 0x800
    if (o.oInteractStatus & INT_STATUS_INTERACTED) ~= 0 then
        obj_mark_for_deletion(o)
        o.oInteractStatus = 0
    end
end

id_bhvCustomSecrets = hook_behavior(bhvCustomSecrets, OBJ_LIST_LEVEL, false, bhv_custom_secrets_init, bhv_custom_secrets_loop)
id_bhvUnTriforce = hook_behavior(bhvUnTriforce, OBJ_LIST_LEVEL, false, bhv_untriforce_init, bhv_untriforce_loop)
--[[
local m = gMarioStates[0]
function testing()
    if (m.controller.buttonPressed & X_BUTTON) ~= 0 then
        spawn_non_sync_object(id_bhvGoomba, E_MODEL_SECRETS, m.pos.x, m.pos.y, m.pos.z, nil)
    end
end

hook_event(HOOK_MARIO_UPDATE, testing) ]]--